<script lang="ts" setup>
import type { Picture } from '~/entities';

defineProps<{
  list: Picture[]
}>();

const user = useAuth();

async function like(picture: Picture) {
  const updated = await $api<Picture>('/api/picture/' + picture.id + '/like', {
    method: 'PATCH'
  });
  picture.likes = updated.likes;
}

function isLiked(picture:Picture) {
  
  return picture.likes?.find(item => item.id == user.value?.id);
}
</script>

<template>
  <div class="row g-3 row-cols-1 row-cols-md-3 row-cols-lg-4">
    <div class="col" v-for="picture of list" :key="picture.id">
      <div class="card">
        <NuxtLink :to="'/picture/' + picture.id">
          <img :src="picture.thumbnailLink" class="card-img-top" :alt="picture.title">
        </NuxtLink>
        <div class="card-body">
          <p>
            <NuxtLink :to="'/user/'+picture.author?.id">{{ picture.author?.displayName }}</NuxtLink>
          </p>
          <p class="card-text">{{ picture.createdAt }}</p>
          <button class="btn btn-outline-primary" @click="like(picture)" :disabled="!user">
            <i class="bi-heart" v-if="!isLiked(picture)"></i>
            <i class="bi-heart-fill" v-else></i>
            {{ picture.likes?.length }}
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped></style>
